AllLatticesD27 := function(G)
    local  g, P, T, D, S, F, R, K, U, W, V, H, sub, i, s, j, r, nat, IG, 
           IS, ID, II, c, w;

    g := Igs(G){[1,2]};
    P := SubgroupByIgs( G, g );
    T := SubgroupByIgs(G, Filtered( Igs(G), x -> RelativeOrder(x) = 0));
    D := DerivedSubgroup( T );

    S := T;
    F := D;

    sub := [  ];
    for i  in [ 1 .. 3 ]  do

        # get relevant subgroups
        F := CommutatorSubgroup( G, F );
        F := CommutatorSubgroup( G, F );
        S := CommutatorSubgroup( G, S );
        R := CommutatorSubgroup( G, S );

        # get a complement
        s := Pcp( S, R )[1];
        S := NormalClosure( P, Subgroup( G, [ s ] ) );

        # check if we can do better at random
        j := Index( T, S );
        for r  in AsList( Pcp( D, F ) )  do
            K := NormalClosure( P, Subgroup( G, [ s * r ] ) );
            if Index( T, K ) > j  then
                S := K;
                j := Index( T, K );
            fi;
            Print( "reduced to ", j, "\n" );
        od;

        # do the rest deterministically
        nat := NaturalHomomorphism( G, F );
        IG := Image( nat );
        IS := Image( nat, S );
        ID := Image( nat, D );
        II := Intersection( IS, ID );
        Print( "complementing subgroup of size ", Size( II ), "\n" );
        c := InvariantComplements( IG, IS, II );
        if Length( c ) = 0  then Error( "hier" ); fi;

        # now add extensions
        U := PreImage( nat, c[1] );

        # the split extension
        V := Subgroup(G, Concatenation(g, Cgs( U )));
        H := PcpGroupByPcp( Pcp( V ) );
        H!.prime := G!.prime;
        H!.param := G!.param;
        H!.cocla := G!.cocla;
        Add( sub, H );
    od;
    return sub;
end;

AllLatticesAndExtensionsD27 := function(G)
    local  g, P, T, D, S, F, R, K, U, W, V, H, sub, i, s, j, r, nat, IG, 
           IS, ID, II, c, w;

    g := Igs(G){[1,2]};
    P := SubgroupByIgs( G, g );
    T := SubgroupByIgs(G, Filtered( Igs(G), x -> RelativeOrder(x) = 0));
    D := DerivedSubgroup( T );

    S := T;
    F := D;

    sub := [  ];
    for i  in [ 1 .. 3 ]  do

        # get relevant subgroups
        F := CommutatorSubgroup( G, F );
        F := CommutatorSubgroup( G, F );
        S := CommutatorSubgroup( G, S );
        R := CommutatorSubgroup( G, S );

        # get a complement
        s := Pcp( S, R )[1];
        S := NormalClosure( P, Subgroup( G, [ s ] ) );

        # check if we can do better at random
        j := Index( T, S );
        for r  in AsList( Pcp( D, F ) )  do
            K := NormalClosure( P, Subgroup( G, [ s * r ] ) );
            if Index( T, K ) > j  then
                S := K;
                j := Index( T, K );
            fi;
            Print( "reduced to ", j, "\n" );
        od;

        # do the rest deterministically
        nat := NaturalHomomorphism( G, F );
        IG := Image( nat );
        IS := Image( nat, S );
        ID := Image( nat, D );
        II := Intersection( IS, ID );
        Print( "complementing subgroup of size ", Size( II ), "\n" );
        c := InvariantComplements( IG, IS, II );
        if Length( c ) = 0  then Error( "hier" ); fi;

        # now add extensions
        U := PreImage( nat, c[1] );

        # the split extension
        V := Subgroup(G, Concatenation(g, Cgs( U )));
        H := PcpGroupByPcp( Pcp( V ) );
        H!.prime := G!.prime;
        H!.param := G!.param;
        H!.cocla := G!.cocla;
        Add( sub, H );

        # the non-split one
        repeat
            s := Random(AsList(Pcp(T,S)));
            w := [g[1], g[2]*s];
            W := Subgroup(G, Concatenation(w, Cgs( U )));

            if Index(G,V) = Index(G,W) and CoclassSpaceGroupPC(W/F) = 2 then
                H := PcpGroupByPcp( Pcp( W ) );
                H!.prime := G!.prime;
                H!.param := G!.param;
                H!.cocla := G!.cocla;
                Add( sub, H );
            fi;
Error();
            Print( "next random try \n");
        until IsInt(Length(sub)/2);
    od;
    return sub;
end;
