
NumberOfUniserials := function( s, p )
    local f, m, n, b;
    f := CyclotomicPolynomial( Rationals, p^s );
    m := CompanionMat(f);
    n := AntiSymmetricPower(m);
    b := NullspaceIntMat( Value( f, n ) );
    return Length(b)/Degree(f);
end;

SplitCyclotomic := function( mat, o )
    local x, g, splt, i;
    if Length(mat) = 1 then return [IdentityMat(Length(mat))]; fi;
    x := Indeterminate( Rationals );
    g := Factors( x^o - 1 );
    splt := List( g, x -> NullspaceIntMat( Value(x,mat) ) );
    splt := Filtered( splt, x -> Length(x) > 0 );
    splt := List( splt, x -> MutableCopyMat(x) );
    return RefineSplitting( [mat], splt );
end;


