
MaximalClassGroups := function(n)
    local res, c;
    res := [];

    # dihedral
    c := FromTheLeftCollector(2);
    SetRelativeOrder(c, 1, 2);
    SetRelativeOrder(c, 2, 2^(n-1));
    SetConjugate(c, 2, 1, [2,2^(n-1)-1]);
    Add(res, PcpGroupByCollector(c));
    if n = 2 then return res; fi;

    # quaternion
    c := FromTheLeftCollector(2);
    SetRelativeOrder(c, 1, 2);
    SetRelativeOrder(c, 2, 2^(n-1));
    SetPower(c, 1, [2,2^(n-2)]);
    SetConjugate(c, 2, 1, [2,2^(n-1)-1]);
    Add(res, PcpGroupByCollector(c));
    if n = 3 then return res; fi;

    # semidihedral
    c := FromTheLeftCollector(2);
    SetRelativeOrder(c, 1, 2);
    SetRelativeOrder(c, 2, 2^(n-1));
    SetConjugate(c, 2, 1, [2,2^(n-2)-1]);
    Add(res, PcpGroupByCollector(c));

    return res;
end;

