
ALLS := [12..26];
TWIG := List([1..17], x -> []);
for l in list do
    i := l[1]; j := l[2]; k := l[3];
    if not IsBound(TWIG[i][j]) then TWIG[i][j] := []; fi;
    file := Concatenation("twigsR/twig_",String(i),"_",String(j),"_",
                            String(k),".gi");
    Read(file);
od;

DisplayBranchInfo := function(j)
    local k, i, T, a, b, l, x;
    for k in [0..BranchLimitR(j)] do
        if k = 0 then x := 100; else x := k; fi;
        for i in [1..17] do
            if IsBound(TWIG[i][j]) and IsBound(TWIG[i][j][x]) then 
                T := TWIG[i][j][x];
                a := DepthOfTwig(T);
                b := SizeOfTwig(T);
                l := 5-Length(DigitsNumber(b,10));
                Print(a,"-",b);
                if l = 1 then Print(" "); fi;
                if l = 2 then Print("  "); fi;
                if l = 3 then Print("   "); fi;
                if l = 4 then Print("    "); fi;
            else
                Print("-------");
            fi;
            if i < 17 then 
                Print("  "); 
            else
                Print("\n");
            fi;
        od;
    od;
    Print("\n");
end;

CompareTwigsR := function(i1, i2)
    local j, k, x;
    for j in ALLS do
        for k in [0..BranchLimitR(j)] do
            if k = 0 then x := 100; else x := k; fi;
            if IsBound(TWIG[i1][j][x]) and IsBound(TWIG[i2][j][x]) then 
                if TWIG[i1][j][x] <> TWIG[i2][j][x] then 
                    return false; 
                fi;
            fi;
        od;
    od;
    return true;
end;

FindSetsR := function()
    local o, i1, i2, r, i;
    o := List([1..17], x -> true);
    for i1 in [2..17] do
        i2 := 1;
        while i2 < i1 do
            if CompareTwigsR(i1,i2) then 
                o[i1] := i2;
                i2 := i1;
            else
                i2 := i2+1;
            fi;
        od;
    od;
    r := Filtered( [1..17], x -> IsBool(o[x]));
    for i in [1..Length(r)] do
        r[i] := Concatenation([r[i]], Filtered([1..17], x -> o[x]=r[i]));
    od;
    return r;
end;

DisplayRFBranchInfo := function()
    local o, r, k, i, T, a, b, l, x;
    o := FindSetsR();
    Print("partition: ",o,"\n \n");
    r := List(o, x -> x[Length(x)]);
    for j in ALLS do
        for k in [0..BranchLimitR(j)] do
            if k = 0 then x := 100; else x := k; fi;
            for i in r do
                if IsBound(TWIG[i][j][x]) then 
                    T := TWIG[i][j][x];
                    a := DepthOfTwig(T);
                    b := SizeOfTwig(T);
                    l := 5-Length(DigitsNumber(b,10));
                    Print(a,"-",b);
                    if l = 1 then Print(" "); fi;
                    if l = 2 then Print("  "); fi;
                    if l = 3 then Print("   "); fi;
                    if l = 4 then Print("    "); fi;
                else
                    Print("-------");
                fi;
                if i < 17 then 
                    Print("  "); 
                else
                    Print("\n");
                fi;
            od;
        od;
        Print("\n");
    od;
end;

CheckTwigs := function()
    local r, i, j, k, T, h, s, p, x;
    r := [];
    s := [];
    p := [];
    for i in [1..17] do
        for j in ALLS do
            for k in [0..BranchLimitR(j)] do
                if k = 0 then x := 100; else x := k; fi;
                if IsBound(TWIG[i][j][x]) then 
                    T := TWIG[i][j][x];
                    h := Position(r, T);
                    if IsBool(h) then 
                        Add(r,T); 
                        h := Position(s, [DepthOfTwig(T), SizeOfTwig(T)]);
                        if IsBool(h) then 
                            Add(p, [i,j,k]);
                        else
                            Add(p, [i,j,k,h]);
                        fi;
                        Add(s, [DepthOfTwig(T),SizeOfTwig(T)]);
                    fi;
                fi;
            od;
        od;
    od;
    return rec(r := r, s := s, p := p);
end;
 
     

    

